<!DOCTYPE html>
{% extends 'sensor_suite_core/base.html' %}
{% load staticfiles %}
{% block body_block %}
    <div class="jumbotron">
        <div class="tool-bar">
            <div class="btn-group">
                <button class="btn btn-main" id="btn-download-xml">SCARICA XML</button>
                <button class="btn btn-main btn-main--grey" id="btn-reload" style="display: none">
                    DISATTIVA AGG. AUTOMATICO
                </button>
                <button class="btn btn-main" id="btn-download-csv">SCARICA CSV</button>
                <button class="btn btn-main" id="btn-download-json">SCARICA JSON</button>
            </div>
        </div>
        <div class="measures-container">
            <div class="form-row header-row">
                <div class="form-group col col-9">
                    <h1 style="text-align: left">
                        <span id="span-machine-name">{{ machine_name }}</span>
                        {% if user.is_superuser %}
                            <a class="fas fa-edit" id="btn-edit-machine-name"></a>
                            <input type="text" class="form-control" id="new-machine-name"
                                   style="display: none" value="{{ machine_name }}">
                            <a class="fas fa-save" id="btn-save-machine-name" style="display: none"></a>
                        {% endif %}
                    </h1>
                </div>
                <div class="div-last-update-date {{ working_class }} watchdog col col-3">
                    <span>{{ working_text }}</span><span class="bold">{{ timestamp }}</span>
                </div>
            </div>
            <div class="panel">
                <table class="table">
                    <tbody>
                    <tr>
                        <td>
                            <span class="bold">MAC: </span><span>{{ mac }}</span>
                        </td>
                        <td>
                            <span class="bold">IPP: </span><span>{{ ipp }}</span>
                        </td>
                        <td>
                            <span class="bold">Wlan0: </span><span>{{ wlan0 }}</span>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="bold">GW: </span><span>{{ gw }}</span>
                        </td>
                        <td>
                            <span class="bold">Versione SW: </span><span>{{ sft_ver }}</span>
                        </td>
                        <td>
                            <span class="bold">Tempo acceso: </span><span>{{ power_up_time }}</span>
                        </td>
                    </tr>

                    {# SENSORS DATA  #}
                    <tr>
                        <td>
                            <span class="bold">ser: </span>
                            {% if 'ser' in data %}
                                <span>{{ data.ser.value }}</span>
                                <span>{{ data.ser.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                        <td>
                            <span class="bold">ttl0: </span>
                            {% if 'ttl0' in data %}
                                <span>{{ data.ttl0.value }}</span>
                                <span>{{ data.ttl0.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                        <td>
                            <span class="bold">ttl1: </span>
                            {% if 'ttl1' in data %}
                                <span>{{ data.ttl1.value }}</span>
                                <span>{{ data.ttl1.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="bold">ttl2: </span>
                            {% if 'ttl2' in data %}
                                <span>{{ data.ttl2.value }}</span>
                                <span>{{ data.ttl2.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                        <td>
                            <span class="bold">ttl3: </span>
                            {% if 'ttl3' in data %}
                                <span>{{ data.ttl3.value }}</span>
                                <span>{{ data.ttl3.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                        <td>
                            <span class="bold">ttl4: </span>
                            {% if 'ttl4' in data %}
                                <span>{{ data.ttl4.value }}</span>
                                <span>{{ data.ttl4.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="bold">ttl5: </span>
                            {% if 'ttl5' in data %}
                                <span>{{ data.ttl5.value }}</span>
                                <span>{{ data.ttl5.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                        <td>
                            <span class="bold">ttl6: </span>
                            {% if 'ttl6' in data %}
                                <span>{{ data.ttl6.value }}</span>
                                <span>{{ data.ttl6.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                        <td>
                            <span class="bold">ttl7: </span>
                            {% if 'ttl7' in data %}
                                <span>{{ data.ttl7.value }}</span>
                                <span>{{ data.ttl7.measurement_translation }}</span>
                            {% else %}
                                <span> - </span>
                            {% endif %}
                        </td>
                    </tr>
                    </tbody>
                </table>

            </div>
            {% comment %}
            <div class="panel">
                <table class="table" id="table-sensors">
                    <thead>
                    <tr>
                        <th>Sensore</th>
                        <th>Unità di misura</th>
                        <th>Valore</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for key, value in data.items %}
                        {% if key and value %}
                            <tr>
                                <td>{{ key }}</td>
                                <td>{{ value.measurement_translation }}</td>
                                <td>{{ value.value }}</td>
                            </tr>
                        {% endif %}
                    {% endfor %}
                    </tbody>
                </table>
            </div>
            {% endcomment %}
        </div>
    </div>
    <script>
        $(function () {
            {% autoescape off %}
                const dataJson = '{{ data_json }}';
                const queryParams = $.param(dataJson);
            {% endautoescape %}
            const reloadButton = $('#btn-reload');
            const xmlButton = $('#btn-download-xml');
            const csvButton = $('#btn-download-csv');
            const jsonButton = $('#btn-download-json');
            const spanMachineName = $('#span-machine-name');

            const reloadTime = 20000;
            let autoReload = true;
            let timeOutFunction;

            {% if user.is_superuser %}
                const editMachineNameButton = $('#btn-edit-machine-name');
                const saveMachineNameButton = $('#btn-save-machine-name');
                const inputMachineName = $('#new-machine-name');
                editMachineNameButton.click(() => {
                    editMachineNameButton.hide();
                    spanMachineName.hide();
                    inputMachineName.show();
                    saveMachineNameButton.show();

                });
                saveMachineNameButton.click(() => {
                    const inputValue = inputMachineName.val();

                    if ((!inputValue)) {
                        alert('Nome inserito non valido');
                        return;
                    }
                    $.post(
                        '{% url 'update_machine_name' %}',
                        {machineName: inputValue}
                    ).done(function (data) {
                        if (data.success)
                            spanMachineName.text(inputValue);
                        editMachineNameButton.show();
                        spanMachineName.show();
                        inputMachineName.hide();
                        saveMachineNameButton.hide();
                        alert(data.message);
                    });

                });
            {% endif %}

            function getFile(action) {
                const completeAction = '{{ request.scheme }}://{{ request.get_host }}' + action
                    + '?' + queryParams;
                window.open(completeAction, '_blank');
            }

            reloadButton.click(() => {
                if (autoReload) {
                    reloadButton.removeClass('btn-main--grey');
                    reloadButton.text('ATTIVA  AGG. AUTOMATICO');
                    autoReload = false;
                    clearTimeout(timeOutFunction);
                } else {
                    reloadButton.addClass('btn-main--grey');
                    reloadButton.text('DISATTIVA AGG. AUTOMATICO');
                    autoReload = true;
                    setReload(reloadTime)
                }
            });
            xmlButton.click(() => {
                getFile('{% url 'get_xml' %}');
            });
            csvButton.click(() => {
                getFile('{% url 'get_csv' %}');
            });
            jsonButton.click(() => {
                getFile('{% url 'get_json' %}');
            });

            function setReload(time) {
                timeOutFunction = setTimeout(function () {
                    if (autoReload)
                        document.location.reload();
                }, time);
            }

            setReload(reloadTime);
            //sortTable('table-sensors');
        });
    </script>
{% endblock %}